Index: trunk/src/kmk/commands.c
===================================================================
--- trunk/src/kmk/commands.c	(revision 1897)
+++ trunk/src/kmk/commands.c	(revision 1898)
@@ -96,8 +96,8 @@
 	{
 	  name = file->name;
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 	  len = strlen (name);
 #else
-	  len = strcache_get_len (name);
+	  len = strcache2_get_len (&file_strcache, name);
 #endif
 	}
@@ -105,8 +105,8 @@
       for (d = enter_file (strcache_add (".SUFFIXES"))->deps; d ; d = d->next)
 	{
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 	  unsigned int slen = strlen (dep_name (d));
 #else
-	  unsigned int slen = strcache_get_len (dep_name (d));
+	  unsigned int slen = strcache2_get_len (&file_strcache, dep_name (d));
 #endif
 	  if (len > slen && strneq (dep_name (d), name + (len - slen), slen))
@@ -164,8 +164,8 @@
     for (d = file->deps; d != 0; d = d->next)
       if (! d->ignore_mtime)
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 	plus_len += strlen (dep_name (d)) + 1;
 #else
-	plus_len += strcache_get_len (dep_name (d)) + 1;
+	plus_len += strcache2_get_len (&file_strcache, dep_name (d)) + 1;
 #endif
     if (plus_len == 0)
@@ -190,8 +190,8 @@
           else
 #endif
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
             len = strlen (c);
 #else
-            len = strcache_get_len (c);
+            len = strcache2_get_len (&file_strcache, c);
 #endif
 
@@ -217,8 +217,8 @@
     for (d = file->deps; d != 0; d = d->next)
       if (d->ignore_mtime)
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 	bar_len += strlen (dep_name (d)) + 1;
 #else
-	bar_len += strcache_get_len (dep_name (d)) + 1;
+	bar_len += strcache2_get_len (&file_strcache, dep_name (d)) + 1;
 #endif
     if (bar_len == 0)
@@ -249,8 +249,8 @@
 	else
 #endif
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 	  len = strlen (c);
 #else
-	  len = strcache_get_len (c);
+	  len = strcache2_get_len (&file_strcache, c);
 #endif
 
Index: trunk/src/kmk/file.c
===================================================================
--- trunk/src/kmk/file.c	(revision 1897)
+++ trunk/src/kmk/file.c	(revision 1898)
@@ -414,5 +414,5 @@
    unsigned int len;
    char *tmp_name = allocated_variable_expand_2 (
-       f->name, strcache_get_len(f->name), &len);
+       f->name, strcache2_get_len (&file_strcache, f->name), &len);
    const char *name = strcache_add_len (tmp_name, len);
    free (tmp_name);
@@ -619,8 +619,8 @@
           p = variable_expand ("");
           buffer_offset = p - variable_buffer;
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
           variable_buffer_output (p, d->name, strlen (d->name) + 1);
 #else
-          len = strcache_get_len (d->name);
+          len = strcache2_get_len (&file_strcache, d->name);
           variable_buffer_output (p, d->name, len + 1);
 #endif
@@ -660,8 +660,8 @@
           set_file_variables (f);
 
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
           p = variable_expand_for_file (d->name, f);
 #else
-          len = strcache_get_len (d->name);
+          len = strcache2_get_len (&file_strcache, d->name);
           p = variable_expand_for_file_2 (NULL, d->name, len, f, &len);
 #endif
@@ -693,5 +693,5 @@
               percent = find_percent (nm);
 #else  /* KMK - don't make a stack copy unless it's actually required! */
-              unsigned int nl = strcache_get_len (dp->name);
+              unsigned int nl = strcache2_get_len (&file_strcache, dp->name);
               char *nm;
               percent = memchr (dp->name, '%', nl);
Index: trunk/src/kmk/read.c
===================================================================
--- trunk/src/kmk/read.c	(revision 1897)
+++ trunk/src/kmk/read.c	(revision 1898)
@@ -1540,8 +1540,8 @@
                     for (d2 = suffix_file->deps; d2 != 0; d2 = d2->next)
                       {
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
                         unsigned int l = strlen (dep_name (d2));
 #else
-                        unsigned int l = strcache_get_len (dep_name (d2));
+                        unsigned int l = strcache2_get_len (&file_strcache, dep_name (d2));
 #endif
                         if (!strneq (name, dep_name (d2), l))
@@ -2154,5 +2154,5 @@
 
 /* Remove duplicate dependencies in CHAIN.  */
-#ifndef CONFIG_WITH_VALUE_LENGTH
+#ifndef CONFIG_WITH_STRCACHE2
 
 static unsigned long
@@ -2185,5 +2185,5 @@
 }
 
-#else  /* CONFIG_WITH_VALUE_LENGTH */
+#else  /* CONFIG_WITH_STRCACHE2 */
 
 /* Exploit the fact that all names are in the string cache. This means equal
@@ -2196,5 +2196,5 @@
 {
   const char *name = dep_name ((struct dep const *) key);
-  assert (strcache_iscached (name));
+  assert (strcache2_is_cached (&file_strcache, name));
   return (size_t) name / sizeof(void *);
 }
@@ -2204,5 +2204,5 @@
 {
   const char *name = dep_name ((struct dep const *) key);
-  return strcache_get_len (name);
+  return strcache2_get_len (&file_strcache, name);
 }
 
@@ -2217,6 +2217,6 @@
 
   /* check preconds: both cached and the cache contains no duplicates. */
-  assert (strcache_iscached (dxname));
-  assert (strcache_iscached (dyname));
+  assert (strcache2_is_cached (&file_strcache, dxname));
+  assert (strcache2_is_cached (&file_strcache, dyname));
   assert (cmp == 0 || strcmp (dxname, dyname) != 0);
 
@@ -2231,5 +2231,5 @@
 }
 
-#endif /* CONFIG_WITH_VALUE_LENGTH */
+#endif /* CONFIG_WITH_STRCACHE2 */
 
 void